/**
 * An object with this interface can act as a "controller" of a
 * canvas.  This is useful for some canvas-derived classes.  The
 * controller is notified when the canvas has finished doing something.
 * The controller also has an opportunity to draw on the canvas during
 * the canvas' paint() call.
 *
 */
 
import java.awt.Canvas;
import java.awt.Graphics;

public interface CanvasController {
    void finishNotify(Canvas caller);
    void paint(Canvas caller, Graphics g);
}

