/*
 *  Image manipulation applet
 *
 *  Steve Robbins, January 1997
 */

import java.applet.Applet;
import java.net.URL;
import java.awt.*;
import java.awt.image.*;

public class ImageManipulator extends Applet
{
    Image sourceImage;
    ImageCanvas before, after;

    private static boolean runsInBrowser = true;
    private Button quitButton, clearButton, nextButton;

    public void init()
    {
	URL u;
	try {
	    u =  new URL("http://localhost/~steve/cbc-logo.gif");
	} catch (java.net.MalformedURLException e) {
	    return;
	}

	sourceImage = Toolkit.getDefaultToolkit().getImage(u);
	setLayout(new BorderLayout());

	// Here be the two images
	//
	before = new ImageCanvas(sourceImage, this, 100, 100);
	after = new ImageCanvas(sourceImage, this, 100, 100);
	add("West", before);
	add("East", after);

	// Here be the controls
	//
	Panel p = new Panel();

	if (!runsInBrowser)
	    p.add(quitButton = new Button("Quit"));

//	p.add(clearButton = new Button("Clear"));
	p.add(nextButton = new Button("Filter"));
	
	add("South", p);

	resize (400,400);
        validate();
    }

    /**
     * This is to run standalone.  It uses AppletFrame, from the java
     * demos (in GraphicsTest directory).
     */
    public static void main (String args[])
    {
	runsInBrowser = false;
	AppletFrame.startApplet("ImageManipulator",
				"Image Processing Demo",
				args);
    }

    public boolean action(Event e, Object arg)
    {
	if (e.target == quitButton) {
	    System.exit (0);
	} else if (e.target == clearButton) {
	    nextButton.disable();
	} else if (e.target == nextButton) {
	    ImageProducer producer = new FilteredImageSource(
		sourceImage.getSource(),
		new NullFilter());
	    after.setImage(createImage(producer));
	} else
	    return false;
	return true;
    }

}



class NullFilter extends TransformFilter
{
    private float pixelValue(int x, int y)
    {
	return raster[x + width * y];
    }
}
